/* GCC */

#define maxn 50000

#include <stdio.h>
#include <vector>

using namespace std;

vector <vector <int> > g;
vector <int> cycle;
int ind[maxn], p;
pair <int, int> restr;

int findcycle(int k, int parent)
{
    ind[k]++;
    for (int i = 0; i < g[k].size(); i++)
        if (ind[g[k][i]] == 0)
            {
            int fc;
            fc = findcycle(g[k][i], k);
            if (fc == 1)
            {
                if (cycle[0] != g[k][i])
                {
                    cycle.push_back(g[k][i]);
                    return 1;
                }
                else
                {
                    return 2;
                }
            }
            else
                if (fc == 2)
                {
                    ind[k]--;
                    return 2;
                }
            }
        else
            if (g[k][i] != parent)
            {
                cycle.push_back(g[k][i]);
                return 1;
            }
    ind[k]--;
    return 0;
}

pair <int, int> dfs(int k)
{
    ind[k]++;
    pair <int, int> ans;
    ans = make_pair(0, 1);
    vector <pair <int, int> > temp;
    for (int i = 0; i < g[k].size(); i++)
        if (ind[g[k][i]] == 0)
            temp.push_back(dfs(g[k][i]));
    for (int i = 0; i < temp.size(); i++)
    {
        int ans1 = 1;
        for (int j = 0; j < temp.size(); j++)
            if (i != j)
            {
                ans1 *= (temp[j]. first + temp[j].second);
                ans1 %= p;
            }
        ans1 *= temp[i].second;
        ans1 %= p;
        ans.first += ans1;
        if (ans.first >= p)
            ans.first -= p;
    }
    for (int i = 0; i < temp.size(); i++)
    {
        ans.second *= (temp[i]. first + temp[i].second);
        ans.second %= p;
    }
    return ans;
}

int main()
{
    freopen("museum.in", "r", stdin);
    freopen("museum.out", "w", stdout);
    int n;
    restr = make_pair(-1, -1);
    scanf("%d %d", &n, &p);
    for (int i = 0; i < n; i++)
    {
        vector <int> temp;
        g.push_back(temp);
    }
    for (int i = 0; i < n; i++)
    {
        int x, y;
        scanf("%d %d", &x, &y);
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    for (int i = 0; i < n; i++)
        ind[i] = 0;
    findcycle(0, 0);
    //int c[10];
    //for (int i = 0; i < cycle.size(); i++)
    //    c[i] = cycle[i];
    int k = 0;
    while (ind[k] > 0)
        k++;
    pair <int, int> ansc1;
    ansc1 = dfs(k);
    int ansc;
    ansc = ansc1.first + ansc1.second;
    if (ansc >= p)
        ansc -= p;
    ansc *= 2;
    if (ansc >= p)
        ansc -= p;
    for (int i = 0; i < n; i++)
        ind[i] = 0;
    ind[cycle[0]] = 1;
    ind[cycle[1]] = 1;
    pair <int, int> ansp01;
    int ansp0 = 1;
    for (int i = 0; i < n; i++)
        if (ind[i] == 0)
        {
            ansp01 = dfs(i);
            ansp0 *= ansp01.first + ansp01.second;
            if (ansp0 >= p)
                ansp0 -= p;
        }
    for (int i = 0; i < n; i++)
        ind[i] = 0;
    restr = make_pair(cycle[0], cycle[1]);
    pair <int, int> ansp11;
    ansp11 = dfs(cycle[0]);
    int ansp1 = ansp11.first + ansp11.second;
    if (ansp1 >= p)
        ansp1 -= p;
    int ans = ansc + ansp0 + ansp1;
    ans %= p;
    printf("%d\n", ans);
    return 0;
}
