/* GCC */
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#define OUT4FILES(taskname) \
    freopen(#taskname".in", "r", stdin); \
    freopen(#taskname".out", "w", stdout); \
    /**/

using namespace std;

struct pt {
    int x, y;
    int d;
};

int n, m;
pt p[2501], q[2501];

bool closer(const pt &first, const pt &second)
{
    double a = sqrt(first.x*first.x + first.y*first.y);
    double b = sqrt(second.x*second.x + second.y*second.y);
    return a < b;
}

bool anticloser(const pt &first, const pt &second)
{
    return !closer(first, second);
}

int main()
{
    OUT4FILES(pairs);
    scanf("%d\n", &n);
    for (int j = 0; j < n; j++) {
        scanf("%d\n", &m);
        for (int i = 0; i < m; i++) {
            scanf("%d %d\n", &p[i].x, &p[i].y);
            p[i].d = i+1;
        }
        for (int i = 0; i < m; i++) {
            scanf("%d %d\n", &q[i].x, &q[i].y);
            q[i].d = i+1;
        }

        sort(p, p+m, closer);
        sort(q, q+m, closer);
        for (int i = 0; i < m; i++)
            printf("%d %d\n", p[i].d, q[i].d);
    }

    return 0;
}

